routes/web.php
<?php

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;


Auth::routes();

//Landing Page
Route::get('/', function () {
    return view('welcome');
});

//minimum user / logged in user
Route::group(['middleware' => ['level:1']], function () {
    //minimum Teacher
    Route::group(['middleware' => ['level:4']], function () {
        Route::group(['middleware' => ['level:5']], function () {
        });
        Route::resource('courses', 'CoursesController');
        Route::resource('courses.assignments', 'AssignmentController');
        Route::resource('courses.assignments.handin','HandinController');
        Route::resource('courses.assignments.handin.grade','GradeController');
        Route::get('courses/{course}/assignments/{assignment}/handin/{handin}/download','HandinController@downloadhandin')->name('course.assignments.handin.download');
        Route::resource('video','VideoController');
        Route::resource('users', 'UserController');

    });

    Route::resource('dashboard', 'DashboardController');

    Route::resource('forum', 'ForumController', ['except' => ['show']])->parameters(['forum' => 'category']);
    Route::resource('forum.topic', 'ForumTopicController')->parameters(['forum' => 'category']);
    Route::resource('forum.topic.post', 'ForumTopicPostController')->parameters(['forum' => 'category']);

    Route::resource('courses', 'CoursesController', ['only' => ['index']]);

    Route::resource('courses.assignments', 'AssignmentController', ['only' => ['index','show']]);
    Route::resource('courses.assignments.handin','HandinController', ['only' => ['create','store']]);

    Route::get('courses/{course}/assignments/{assignment}/handin/{handin}/download','HandinController@downloadhandin')->name('course.assignments.handin.download');

    Route::resource('profile', 'ProfileController');
    Route::resource('dashboard', 'DashboardController');
    Route::resource('contact','ContactController');
    Route::post('search', 'DashboardController@search')->name('search');

    Route::resource('videos', 'VideoController');

    //botman routes
    Route::match(['get', 'post'], '/botman', 'BotManController@handle');
});

app/Handin.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Handin extends Model
{
    public function assignments(){
        return $this->belongsTo(Assignment::class);
    }
    public function user(){
        return $this->belongsTo(User::class);
    }
    public function grade(){
        return $this->hasOne(Grade::class,'handin_id');
    }

}

app/Http/Controllers/HandinController.php
<?php

namespace App\Http\Controllers;

use App\Assignment;
use App\Course;
use App\Handin;
use App\Http\Requests\CreateHandinRequest;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Response;
use PhpParser\Node\Expr\Assign;

class HandinController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @param Course $course
     * @param Assignment $assignment
     * @return \Illuminate\Contracts\Foundation\Application|\Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function index(Course $course, Assignment $assignment)
    {
        return view('handin.index', ['course' => $course, 'assignment' => $assignment, 'handins' => $assignment->handins, 'user' => Auth::user()]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @param Course $course
     * @param Assignment $assignment
     * @return \Illuminate\Contracts\Foundation\Application|\Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function create(Course $course, Assignment $assignment)
    {
       return view('handin.create', ['course' => $course, 'assignment' => $assignment]);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param CreateHandinRequest $request
     * @param Course $course
     * @param Assignment $assignment
     * @return \Illuminate\Http\RedirectResponse
     */
    public function store(CreateHandinRequest $request,Course $course,Assignment $assignment)
    {
        if (!$request->validated()) {
            return redirect()->back()->withInput($request->input())->withErrors($request);
        }
        $handin = new Handin();
        if ($request->file('file') != null) {
            $file = $request->file('file')->store('/public/files');
            $file = str_replace('public/files/', '', $file);
            $handin->file = $file;
        }

        $handin->user_id = Auth::id();
        $handin->assignment_id = $assignment->id;
        $handin->info = $request['info'];
        $handin->save();
        return redirect()->route('courses.assignments.show',['course'=>$course,'assignment'=>$assignment])->with('Submitted!');
    }

    /**
     * Display the specified resource.
     *
     * @param Course $course
     * @param Assignment $assignment
     * @param \App\Handin $handin
     * @return \Illuminate\Contracts\Foundation\Application|\Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function show(Course $course, Assignment $assignment,Handin $handin)
    {
        return view('handin.show',['course'=>$course,'assignment'=>$assignment,'handin'=>$handin,'user'=>Auth::user()]);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Handin $handin
     * @return \Illuminate\Http\Response
     */
    public function edit(Handin $handin)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request $request
     * @param  \App\Handin $handin
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Handin $handin)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Handin $handin
     * @return \Illuminate\Http\Response
     */
    public function destroy(Handin $handin)
    {
        //
    }

    public function downloadhandin(Course $course, Assignment $assignment, Handin $handin)
    {
        return response()->download('storage/files/'.$handin->file);
    }
}

resources/views/handin/create.blade.php
@extends('layouts.app')
@section('content')
    <nav aria-label="breadcrumb">
        <ol class="breadcrumb">
            <li class="breadcrumb-item"><a href="{{route('dashboard.index')}}">Dashboard</a></li>
            <li class="breadcrumb-item"><a href="{{route('courses.index',$course)}}">Courses</a></li>
            <li class="breadcrumb-item"><a href="{{route('courses.assignments.index',$course)}}">Assignments</a></li>
            <li class="breadcrumb-item"><a href="{{route('courses.assignments.show',[$course,$assignment])}}">Assignment overview</a></li>
            <li class="breadcrumb-item active" aria-current="page">Assignment handin</li>
        </ol>
    </nav>
    <!-- The Modal -->
    <div class="modal-dialog">
        <div class="modal-content">
            {{ Form::open(array('route' => array('courses.assignments.handin.store',$course,$assignment),'method'=>'post','files'=>true)) }}
                <!-- Modal Header -->
                <div class="modal-header">
                    <h4 class="modal-title">Handin</h4>
                    <button type="button" class="close" data-dismiss="modal">&times;</button>
                </div>
                <!-- Modal body -->
                <div class="card">
                    @csrf
                    @foreach($errors->all() as $error)
                        <p class="text-danger">
                            {{ $error }}
                        </p>
                    @endforeach
                    <div class="card-body">

                        {{ Form::text('info',null,array('class'=>'form-control')) }}
                        {{ Form::label('file', 'File') }}
                        {{Form::file('file')}}
                    </div>
                </div>
                <!-- Modal footer -->
                <div class="modal-footer">
                    {{Form::submit('Save',array('class'=>'btn btn-primary'))}}
                    {{Form::close()}}
                    <button type="button" class="btn btn-danger" data-dismiss="modal">Sluiten</button>
                </div>
        </div>
    </div>
@endsection

resources/views/handin/index.blade.php
@extends('layouts.dashboard')
@section('content')
    <nav aria-label="breadcrumb">
        <ol class="breadcrumb">
            <li class="breadcrumb-item"><a href="{{route('dashboard.index')}}">Dashboard</a></li>
            <li class="breadcrumb-item"><a href="{{route('courses.index')}}">Courses</a></li>
            <li class="breadcrumb-item"><a href="{{route('courses.assignments.index',[$course,$assignment])}}">Assignments</a></li>
            <li class="breadcrumb-item"><a href="{{route('courses.assignments.show',[$course,$assignment])}}">Assignment overview</a></li>
            <li class="breadcrumb-item active" aria-current="page">Handins</li>
        </ol>
    </nav>
    <div class="container-sm">
        <table class="table">
            <thead>
            <tr>
                <th scope="col">User</th>
                <th scope="col">Information</th>
                <th scope="col">Grade</th>
                <th scope="col">File</th>
            </tr>
            </thead>
            <tbody>
            @foreach($handins as $handin)
                <tr>
                    <th scope="row">{{$handin->user->name}} ({{$handin->user->email}})</th>
                    <td>{{$handin->info}}</td>
                    @if($user->hasRole('admin|teacher'))
                    <td><a class="btn btn-success" href="{{route('courses.assignments.handin.show',[$course->id,$handin->assignment_id,$handin])}}">Give grade</a></td>
                    @endif
                    <td><a class="btn btn-primary" href="{{route('course.assignments.handin.download',[$course,$assignment,$handin])}}">Download</a></td>
                </tr>
            @endforeach
            </tbody>
        </table>
    </div>
@endsection

resources/views/handin/show.blade.php
@extends('layouts.dashboard')
@section ('title', 'Assignments |' . $assignment->name)
@section('content')
    <nav aria-label="breadcrumb">
        <ol class="breadcrumb">
            <li class="breadcrumb-item"><a href="{{route('dashboard.index')}}">Dashboard</a></li>
            <li class="breadcrumb-item"><a href="{{route('courses.index',$course)}}">Courses</a></li>
            <li class="breadcrumb-item"><a href="{{route('courses.assignments.index',$course)}}">Assignments</a></li>
            <li class="breadcrumb-item"><a href="{{route('courses.assignments.show',[$course,$assignment])}}">Assignment overview</a></li>
            <li class="breadcrumb-item"><a href="{{route('courses.assignments.handin.index',[$course,$assignment])}}">Handins</a></li>
            <li class="breadcrumb-item active" aria-current="page">Handin overview</li>
        </ol>
    </nav>
    <div class="container">
        <div class="row">
            <div class="col-12 col-sm-10 col-lg-6 mx-auto">
                <h1 class="display-4" style="text-align: center; margin: 50px 0;">Assignment</h1>
                <div class="form-group py-3 px-4 shadow rounded">
                    @if(isset($handin->grade->id))
                        <p class="font-weight-bold float-right" style="font-size: 24px;">Grade: {{$handin->grade->grade}} </p>
                    @endif
                    <label for="title "><h4 class="font-weight-bold">Title:</h4></label>
                    <p>{{$assignment->name}}</p>
                    <label for="Description"><h4 class="font-weight-bold">Description:</h4></label>
                    <p>{{$assignment->description}}</p>
                    @if(isset($handin->id))
                        <div style="padding:5px 0 15px 0;">
                            <a class="btn btn-success" href="{{route('course.assignments.handin.download',[$course,$assignment,$handin])}}">Download submitted assignment</a>
                        </div>
                    @else
                        <div style="padding:5px 0 15px 0;">
                            <a class="btn btn-success float-right" href="{{route('courses.assignments.handin.create',[$course,$assignment])}}">Handin assignment</a>
                        </div>
                    @endif
                    @if(isset($handin->grade->id))
                        <div class="card">
                            <div class="card-body">
                                <h5 class="font-weight-bold" style="font-size: 20px;">Comment:</h5>
                                <p>{{$handin->grade->comment}}</p>
                            </div>
                        </div>
                    @endif
                    @if($user->hasRole('admin|teacher')&& isset($handin->id))
                        <br><br><br>
                        @if(isset($handin->grade->id))
                            <form action="{{route('courses.assignments.handin.grade.update',[$course->id,$assignment->id,$handin->id,$handin->grade->id])}}" method="post" class="form-group">@method('PUT')@csrf
                        @else
                            <form action="{{route('courses.assignments.handin.grade.store',[$course->id,$assignment->id,$handin->id])}}" method="post" class="form-group">@csrf
                        @endif
                                <label for="grade">Grade:</label>
                                <input id="grade" type="number" name="grade" class="form-control" value="@if(isset($handin->grade->id)){{$handin->grade->grade}}@endif" required>
                                <label for="comment">Comment:</label>
                                <textarea id="comment" name="comment" class="form-control" rows="2" required>@if(isset($handin->grade->id)){{$handin->grade->comment}}@endif</textarea>
                        @if(isset($handin->grade->id))
                                <button type="submit" class="btn btn-primary mt-3">Update grade</button>
                        @else
                                <button type="submit" class="btn btn-primary mt-3">Give grade</button>
                        @endif
                            </form>
                        @foreach($errors->all() as $error)
                            <p class="text-danger">
                                {{ $error }}
                            </p>
                        @endforeach
                    @endif
                </div>
            </div>
        </div>
    </div>
@endsection